'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: status.inc,v $
'*
'*  $Revision: 1.9.2.7 $
'*
'*  last change: $Author: tbo $ $Date: 2004/02/12 11:50:22 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/****************************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Routines for the status page feature
'*
'*********************************************************************************************
'*
' #1   hStatusIn                   ' initilize variables before the teststart
' #1   hStatusOut                  ' last routine to generate write datas for status-page
' #1   hStatusWriteOutput          ' write the data in a list and when Duration <> '00:00:00' then the list will be writen
' #1   StatusIntoDatabase          ' put all data out of the log-file into the history-database
'*
'\*****************************************************************************************

sub hStatusIn ( sTestAppArea as String, sTestname as String, optional sName as String )
    Dim IsoData$, y$, m$, d$

'///hStatusIn : initilize variables before the teststart
'///  input  : sTestAppArea => which application should be tested by this test ( writer, calc, framework etc. )
'///+_         sTestname    => name of the test
'///+_         sTestname    => name of the test
'///+ output : gTestname    => global name of the test
'///+_       : gTestAppArea => global name of the tested application
'///+_       : gTestDate    => global start date of the test ( yyyy-mm-dd )
'///+_       : gTestTime    => global start time of the test
'///+_       : gTestDescr   => short description for the test

    if gCWS = TRUE then
   exit sub
  end if
  if gMahler = FALSE then
   exit sub
  end if

  Dim sDummy as String

   sDummy = date
   gTestName = lcase ( sTestname )
   gTestAppArea = lcase ( sTestAppArea )

   'Get the System date to find the format of date and time.
   IsoData$ = CDateToIso( DateValue( Date ) )
   y$ = left$( IsoData$, 4 )
   m$ = mid$( IsoData$, 5, 2 )
   d$ = right$( IsoData$, 2 )
   gTestDate = y$ + "-" + m$ + "-" + d$


   if isMissing ( sName ) = TRUE then
      gTestDescr = "No short description!"
   else
      gTestDescr = sName
   end if
   
   if( iSystemSprache = 01 ) then
    gTestTime = TimeValue( Time() )
   else
    gTestTime = Format( Time, "hh:mm:ss" )
   endif
   
   gStatusDuration = now ()
   ListAllDelete ( glsStatusPage () )
   gErrorSum = 0
   gWarningSum = 0

end sub

' ****************************************
' *
sub hStatusOut ( optional NoKill as Boolean )
'///hStatusOut : last output for the status-page feature
'///+ -> create the duration value for the test and call the routine to write the data into the database

   Dim Zeitspanne
   Dim Zeitspannesek
   Dim Zeitspannemin
   Dim Zeitspanneh
   Dim sDummy as String

  if gCWS = TRUE then
   exit sub
  end if
  if gMahler = FALSE then
   exit sub
  end if

   Zeitspanne = Now() - gStatusDuration
   Zeitspannesek = Zeitspanne / 1.15741E-05 + 1
   Zeitspanneh = Fix(Zeitspannesek / 3600)
   Zeitspannesek = Zeitspannesek - Zeitspanneh * 3600
   Zeitspannemin = Fix(Zeitspannesek / 60)
   Zeitspannesek = Zeitspannesek - Zeitspannemin * 60
   Zeitspannesek = Fix(Zeitspannesek)
   if Zeitspanneh < 10 then
      sDummy = "0" & Zeitspanneh & ":"
   else
      sDummy = "" & Zeitspanneh & ":"
   end if
   if Zeitspannemin < 10 then
      sDummy = "" & sDummy & "0" & Zeitspannemin & ":"
   else
      sDummy = "" & sDummy & Zeitspannemin & ":"
   end if
   if Zeitspannesek < 10 then
      sDummy = "" & sDummy & "0" & Zeitspannesek & ":"
   else
      sDummy = "" & sDummy & Zeitspannesek
   end if

   if isMissing ( NoKill ) = TRUE then
      hStatusWriteOutput ( sDummy, FALSE )
   else
      hStatusWriteOutput ( sDummy, NoKill )
   end if

  PrintLog Chr(13) + "* - End of the test - *"
  Printlog "Date : " + Date() + "   Time: " + Time()
  Printlog "Duration : " + WieLange ( gStatusDuration )

end sub

' ****************************************
' *
sub hStatusWriteOutput ( sDur as String, optional NoKill as Boolean )
   Dim sOutput as String, sPlat as String, sTCname as String, sOutFile as String, sBuildHisPath as string
   Dim i as Integer, iCut as Integer
   Dim bNoKill as Boolean
   dim iIsNet as integer
    dim sMajor as string
    dim sMinor as string
    dim sMinorNr as integer
    dim slVersion() as string
    dim ilVersion as integer
    dim sLastVersion as string

   if isMissing ( NoKill ) = TRUE then
      bNoKill = FALSE
   else
      bNoKill = NoKill
   end if
   
   if gNetzInst then
        iIsNet = 1
   else
        iIsNet = 0
   endif

'///hStatusWriteOutput : output routine for status page of our testscripts
'///+- all outputs for each testcase are collected in a list ( duration time is 00:00:00 )
'///+- for the last entry ( test end ) the duration time is set to correct data

'///The entries in the list are ( seperated by TAB ) :
'///+ date ( gTestDate ) => fix date when the test started
'///+ time ( gTestTime ) => fix time when the test started
'///+ major => major number of full buildID of StarOffice ( e.g. '642' )
'///+ minor => minor number of full buildID of StarOffice ( e.g.'L' )
'///+ buildID => only the buildID of full buildID of StarOffice ( e.g.'7733' )
'///+ platform => short cut for platform
'///+ machine name => name of the PC or UNIX-machine where the test is running
'///+ user name => namen of the user who run the test ( on windows vcsid must be set as globale system variable )
'///+ test name => name of the test ( e.g. first.bas )
'///+ testcase name => name of the current testcase in the running test
'///+ file name => name of the file in which the testcase is
'///+ errors => only the errors for the current testcase
'///+ warnings => only the warnings for the current testcase
'///+ duration => the duration of te whole test, output for testcases are 00:00:00

   if gPlatgroup = "unx" then
      sPlat = gPlatform
   else
      sPlat = "win"
   end if
   
   if sDur <> "00:00:00" then
      sTCname = "test end"
      gErrorSum = GetErrorCount                           ' at the end the sum of all errors
      gWarningSum = GetWarningCount                       ' at the end the sum of all warnings
   else
      sTCname = GetTestcaseName
      iCut = Instr ( sTCname, "(" )
      if iCut <> 0 then sTCname = Left ( sTCname, iCut - 1 )
      sTCname = Trim ( sTCname )
      gErrorSum = GetErrorCount - gErrorSum               ' only the errors in a testcase
      gWarningSum = GetWarningCount - gWarningSum         ' only the warnings in a testcase
   end if

        ' since #112922# we'll be able to see the applied patches: '645m18(Build:8687),645m18(Build:8687)[CWS:so7aighotpatch],schnubbel'
        slVersion() = Split(gVersionsnummer, ",") 
        ilVersion = uBound(slVersion()) ' array counts from 0 on!
        sLastVersion = slVersion(ilVersion)
'        for i = 0 to ilVersion
'            printlog "" + i + ": '" + slVersion(i) + "'"
'        next i
    ' gPatch = (iVersion > 0)  ' is patched version?
    ' if version is SRX645m21 or greater, put status as SRX645pp1m20 into database
    'major;minor 
    sMajor = Left(sLastVersion,3)
    sMinor = Mid(sLastVersion,4,Len(sLastVersion)-15)
    sMinorNr = val(mid(sMinor,2,len(sMinor)))
    if ("645"= sMajor) then
        select case sMinorNr
            case > 23 : sMajor = "645pp2"
            case < 10 : sMajor = "645pp2"
        end select
    endif
    
   sOutput = Chr(9) + gTestDate + Chr(9) + gTestTime + Chr(9) + gTestAppArea + Chr(9) + sMajor + Chr(9) _
             + Mid ( sLastVersion, 4, Len(sLastVersion)-15 ) + Chr(9) + Mid ( sLastVersion, Len ( sLastVersion )-4, 4 ) _
             + Chr(9) + sPlat + Chr(9) + gPCName + Chr(9) + gUser + Chr(9) + gTestName + Chr(9) + DateiExtract ( GetTestcaseFileName ) _
             + Chr(9) + sTCname + Chr(9) + gLanguage + Chr(9) + gErrorSum + Chr(9) + gWarningSum + Chr(9) + sDur _
             + Chr(9) + "" + Chr(9) + "" + Chr(9) + gUserGroup + Chr(9) + iIsNet

   ListAppend ( glsStatusPage (), sOutPut )

' only for debugging output-errors
'      printlog "Date     : " + gTestDate
'      printlog "Time     : " + gTestTime
'      printlog "Major    : " + Left ( gVersionsnummer, 3 )
'      printlog "Minor    : " + Mid ( gVersionsnummer, 4, Len(gVersionsnummer)-15 )
'      printlog "BuildID  : " + Mid ( gVersionsnummer, Len(gVersionsnummer)-4, 4 )
'      printlog "Platform : " + sPlat
'      printlog "Machine  : " + gPCName
'      printlog "User     : " + gUser
'      printlog "Test name: " + gTestName
'      printlog "Inc-name : " + DateiExtract ( GetTestcaseFileName )
'      printlog "Testcase : " + sTCname
'      printlog "Language : " + gLanguage
'      printlog "Errors   : " + gErrorSum
'      printlog "Warning  : " + gWarningSum
'      printlog "Duration : " + sDur
'      printlog "Test area: " + gTestAppArea

   gErrorSum = GetErrorCount                  ' to set the variable to the current error number
   gWarningSum = GetWarningCount              ' to set the variable to the current warning number

'///if the last entry is in the list ( duration <> 00:00:00 ) then the list will be writen at
'///+ /export/home/q_testtool/history/tooling/database/*.log

   if sDur <> "00:00:00" then
      if gPlatGroup = "unx" then
         sBuildHisPath = "/q_testtool/history/tooling/database/"
         if Dir ( ConvertPath ( sBuildHisPath ), 16) = "" then     ' trie usual location, where /q_testtool is in root directory
            sBuildHisPath= "/net/mahler/export/software" + sBuildHisPath    ' failed, so go via automounter /net/mahler/...
            if Dir ( ConvertPath ( sBuildHisPath ),16) = "" then
               warnlog "can't find location of database :-( " + sBuildHisPath
           endif
        endif
         sOutFile = lcase ( sBuildHisPath + sPlat + gUser + gPCname + Left ( gTestname, Len ( gTestname ) - 4 ) + ".log" )
      else
         sOutFile = lcase ( "v:\history\tooling\database\" + sPlat + gUser + gPCname + Left ( gTestname, Len ( gTestname ) - 4 ) + ".log" )
      end if
      if Dir ( sOutFile ) <> "" then
         if bNoKill = FALSE then kill sOutFile
         Sleep (1)
         if dir (sOutFile) <> "" then warnlog "File wasn't deleted: " + sOutFile
      end if
      ListWrite ( glsStatusPage (), ConvertPath (sOutFile) )
      if dir (sOutFile) = "" then warnlog "File wasn't created: " + sOutFile
      StatusIntoDatabase ( sOutFile, sPlat, bNoKill )
      for i=1 to 20
         try
            if Dir ( sOutFile ) <> "" then
               if bNoKill = FALSE then kill ( sOutFile )
            end if
         catch
            Sleep (2)
         endcatch
      next i
      if dir (sOutFile) <> "" then warnlog "File wasn't deleted: " + sOutFile
      ListAllDelete ( glsStatusPage () )                ' delete the list, because if you want to use hStatusIn twice or more
   end if

end sub

' ****************************************
' *
sub StatusIntoDatabase ( sFile as String, ssPlat as String, NoKill as Boolean )
'///StatusIntoDatabase : write the collected data into the database

  Dim sInput as String, sDataInputFile as String, sFile2 as String
  Dim i as Integer
  Dim iShellReturn as integer, sPlat as String, sBuildHisPath as string
  dim sDebugInfo as string
  dim sTemp as string
  dim iIsNet as integer
    dim sMajor as string
    dim sMinor as string
    dim sMinorNr as integer
    dim slVersion() as string
    dim ilVersion as integer
    dim sLastVersion as string

   if gNetzInst then
        iIsNet = 1
   else
        iIsNet = 0
   endif

   if gPlatgroup = "unx" then
      sPlat = gPlatform
   else
      sPlat = "win"
   end if

   sFile2 = DateiExtract ( ConvertPath ( sFile ) )
   sFile2 = "/q_testtool/history/tooling/database/" + sFile2

   if gPlatGroup = "unx" then
         sBuildHisPath = "/q_testtool/history/tooling/"
         if Dir ( sBuildHisPath , 16) = "" then     ' trie usual location, where /q_testtool is in root directory
            sBuildHisPath= "/net/mahler/export/software" + sBuildHisPath    ' failed, so go via automounter /net/mahler/...
            if Dir ( sBuildHisPath ,16) = "" then
               warnlog "can't find location of database :-( " + sBuildHisPath
           endif
        endif
      sDataInputFile =  sBuildHisPath + sPlat + lcase ( gUser ) + lcase ( gPCName )
   else
      sDataInputFile = "v:\history\tooling\" + Left ( sPlat + lcase ( gUser ) + lcase ( gPCName ), 8 )
   end if

        ' since #112922# we'll be able to see the applied patches: '645m18(Build:8687),645m18(Build:8687)[CWS:so7aighotpatch],schnubbel'
        slVersion() = Split(gVersionsnummer, ",") 
        ilVersion = uBound(slVersion()) ' array counts from 0 on!
        sLastVersion = slVersion(ilVersion)
'        for i = 0 to ilVersion
'            printlog "" + i + ": '" + slVersion(i) + "'"
'        next i
    ' gPatch = (iVersion > 0)  ' is patched version?
    ' if version is SRX645m21 or greater, put status as SRX645pp1m20 into database
    'major;minor 
    sMajor = Left(sLastVersion,3)
    sMinor = Mid(sLastVersion,4,Len(sLastVersion)-15)
    sMinorNr = val(mid(sMinor,2,len(sMinor)))
    if ("645"= sMajor) then
        select case sMinorNr
            case > 23 : sMajor = "645pp2"
            case < 10 : sMajor = "645pp2"
        end select
    endif

'///+- a textfile with the sql-command will be writen at /export/software/q_testtool/history/tooling/..
   sInput =  "delete from autotest_analysis where testname = '" + gTestName + "' and office_major = '" + sMAjor _
             + "' AND office_minor = '" + Mid ( sLastVersion, 4, Len(sLastVersion)-15 ) + "' AND Platform = '" + ssPlat _
             + "' AND BuildID = '" + Mid ( sLastVersion, Len ( sLastVersion )-4, 4 ) + "' AND hlanguage = '" + glanguage + _
             + "' AND User = '" + gUser + "' AND Machine = '" + gPCname + "' AND user_group = '" + gUserGroup + "' AND is_net = '" + iIsNet + "';" + _
             + "load data infile '" + sFile2 +"' into table autotest_analysis;" _
             + "delete from autotest_application where happlication = '" + gTestAppArea + "' AND htestname = '" _
             + gTestName + "' AND h_language = '" + glanguage + "' AND h_platform = '" + ssPlat + "' AND user_group = '" + gUserGroup + "' AND is_net = '" + iIsNet + "';insert into autotest_application ( happlication, htestname, hdescription, hversion, h_date, h_language, h_warnings, h_errors, h_platform, user_group, is_net ) values " + _
             + "( '" + gTestAppArea + "','" + gTestName + "','" + gTestDescr + "','" + sMAjor + "','" + gTestDate + "','" + glanguage + "','" + gWarningSum + "','" + gErrorSum + "','" + ssPlat + "','" + gUserGroup+ "','" + iIsNet + "' );"

   Call TextInDatei ( sInput, sDataInputFile )
   if dir (sDataInputFile) = "" then warnlog "File wasn't created :-( : " + sDataInputFile

'///+- a batch file or shell script with the mysql-command will be writen at /export/software/q_testtool/history/tooling/..
   if (NoKill) then ' enable output of mysql status information in rersultfile
       sDebugInfo = ConvertPath (gOfficePath + "user\work\status.txt")
       sTemp = " > " + chr(34) + sDebugInfo + chr(34)
   else
       sTemp = ""
   endif
   if gPlatgroup = "unx" then
      sInput = "cd "+ sBuildHisPath + Chr(13) +  _
               "./mysql."+gPlatform + " -vv -h mahler -u testtool qa_history <" + sPlat + lcase ( gUser ) + lcase ( gPCName ) + sTemp
               
      if Dir ( sDataInputFile + ".sh" ) <> "" then
         if NoKill = FALSE then kill sDataInputFile + ".sh"
         Sleep (1)
         if dir (sDataInputFile+".sh") <> "" then warnlog "File wasn't deleted: " + sDataInputFile+".sh"
      end if
      Call TextInDatei ( sInput, sDataInputFile + ".sh" )
      if dir (sDataInputFile+".sh") = "" then warnlog "File wasn't created: " + sDataInputFile+".sh"
      iShellReturn = Shell ( "sh " + sDataInputFile + ".sh", 1, "dumy", true)
      if iShellReturn <> 0 then warnlog "no program called 'sh' available."
      Sleep 10
   else
      sInput = "v:" + Chr(13) + "cd \history\tooling" + Chr(13) + _
               "mysql -vv -h mahler -u testtool qa_history <" + Left ( sPlat + lcase ( gUser ) + lcase ( gPCName ), 8 ) + sTemp

      if Dir ( sDataInputFile + ".bat" ) <> "" then
         if NoKill = FALSE then kill sDataInputFile + ".bat"
         Sleep (1)
         if dir (sDataInputFile+".bat") <> "" then warnlog "File wasn't deleted: " + sDataInputFile+".bat"
      end if
      Call TextInDatei ( sInput, sDataInputFile + ".bat" )
      if dir (sDataInputFile+".bat") = "" then warnlog "File wasn't created: " + sDataInputFile+".bat"
      Shell ( sDataInputFile + ".bat", 1, "dumy", true)
      Sleep 10
   end if
   if (NoKill) then tDebugInfoMysql (sDebugInfo)

'///+- all files will be deleted
   for i=1 to 20
      try
         if Dir ( sDataInputFile ) <> "" then
            if NoKill = FALSE then  Kill ( sDataInputFile )
         end if
         if dir (sDataInputFile) <> "" then warnlog "File wasn't deleted: " + sDataInputFile
      catch
         Sleep (2)
         if dir (sDataInputFile) <> "" then warnlog " CATCH! File wasn't deleted: " + sDataInputFile
      endcatch
      try
         if gPlatGroup = "unx" then
            if Dir ( ConvertPath (sDataInputFile + ".sh") ) <> "" then
               if NoKill = FALSE then Kill ( ConvertPath (sDataInputFile + ".sh") )
            end if
            if dir ( ConvertPath (sDataInputFile + ".sh") ) <> "" then warnlog "File wasn't deleted: " + ConvertPath (sDataInputFile+".sh")
         else
            if Dir ( sDataInputFile + ".bat" ) <> "" then
               if NoKill = FALSE then Kill ( sDataInputFile + ".bat" )
            end if
            if dir (sDataInputFile+".bat") <> "" then warnlog "File wasn't deleted: " + sDataInputFile+".bat"
         end if
         i= 100
      catch
         Sleep (2)
      endcatch
   next i
end sub

'-------------------------------------------------------------------------
testcase tDebugInfoMysql (sTemp as string)
' to show the dubuginfo folded in a testcase (if nokill = true)
    dim fTemp(900) as string

    fTemp(0)=0
    try
        ListRead (fTemp(), sTemp)
        for i=1 to ListCount (fTemp())
            if (fTemp(i) <> "") then printlog fTemp(i)
        next i
    catch
    endcatch
endcase
