'*************************************************************************
'*
'*  $RCSfile: getnames.bas,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:37 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Creates lists of language dependent filters and OLE objects
'*
'************************************************************************
'*
' #1 GetFilterNames 'Gets the language dependent filter names (UI)
' #1 GetOLEObjectNames 'Gets the language dependent OLE object names (UI)
' #0 LoadIncludeFiles  
'*
'\***********************************************************************
sub main
  if gPlatgroup = "unx" then
    warnlog "Please use a Win32 version to get ALL OLE strings!"
   else
    call GetFilterNames                    ' to create the filtername-list
    call GetOLEObjectNames                 ' to create the OLE-object-list
  end if
end sub

'-------------------------------------------------------------------------

testcase GetFilterNames
'/// Get the filter-lists of default-filters for all applications and
'///+the lists will be written in <i>..\global\input\filters\filter[ LangaugeID ].txt</i>.

  Dim sFilterNames (20) as String
  Dim sAppShortName as String, sFile as String, sDummy as String
  Dim i as Integer

   for i = 1 to 7
      select case i
         case 1 : gApplication = "WRITER"      : sAppShortName = "sw"
         case 2 : gApplication = "CALC"        : sAppShortName = "sc"
         case 3 : gApplication = "IMPRESS"     : sAppShortName = "si"
         case 4 : gApplication = "DRAW"        : sAppShortName = "sd"
         case 5 : gApplication = "MATH"        : sAppShortName = "sm"
         case 6 : gApplication = "HTML"        : sAppShortName = "ht"
         case 7 : gApplication = "MASTERDOC"   : sAppShortName = "sg"
      end select
      printlog "  - " +  gApplication
      try
         call hNewDocument
         FileSaveAs
         Kontext "SpeichernDlg"
          sDummy = sAppShortName + "=" + DateiTyp.GetItemText (1)
          ListAppend ( sFilterNames (), sDummy )
          SpeichernDlg.Cancel
         call hCloseDocument
       catch
         Exceptlog
         ResetApplication
         ListAppend ( sFilterNames (), sAppShortName + "=error" )
      endcatch
   next i

   sFile = ConvertPath ( gTesttoolPath + "global\input\filters\filter" + iSprache + ".txt" )
   ListWrite ( sFilterNames(), sFile, "utf8" )
   warnlog "Please check " + sFile + " ( UTF8 encoded )!"
endcase

'-------------------------------------------------------------------------

testcase GetOLEObjectNames
'/// Get the lists of language dependent OLE entries for all applications and
'///+the lists will be written in <i>..global\input\filters\olenames\ole_[ LangaugeID ].txt</i>.
  Dim sOLENames (20) as String
  Dim sDummy as String
  Dim sFile as String

   gApplication = "WRITER"
   call hNewDocument
   InsertObjectOLEObjekt
   Kontext "OLEObjektEinfuegen"
    sDummy = "sc=" + Objekttyp.GetItemText(1)     ' calc
    ListAppend ( sOLENames (), sDummy )
    sDummy = "sh=" + Objekttyp.GetItemText(2)     ' chart
    ListAppend ( sOLENames (), sDummy )
    sDummy = "sd=" + Objekttyp.GetItemText(3)     ' draw
    ListAppend ( sOLENames (), sDummy )
    sDummy = "si=" + Objekttyp.GetItemText(4)     ' impress
    ListAppend ( sOLENames (), sDummy )
    sDummy = "sm=" + Objekttyp.GetItemText(5)     ' math
    ListAppend ( sOLENames (), sDummy )
    OLEObjektEinfuegen.Cancel
   call hCloseDocument

   gApplication = "CALC"
   call hNewDocument
   InsertObjectOLEObjekt
   Kontext "OLEObjektEinfuegen"
    sDummy = "sw=" + Objekttyp.GetItemText(5)     ' writer
    ListAppend ( sOLENames (), sDummy )
    sDummy = "ot=" + Objekttyp.GetItemText(6)     ' other
    ListAppend ( sOLENames (), sDummy )
    OLEObjektEinfuegen.Cancel
   call hCloseDocument

   sFile = ConvertPath ( gTesttoolPath + "global\input\olenames\ole_" + iSprache + ".txt" )
   if bAsianLan = TRUE then
      ListWrite ( sOLENames(), sFile, "utf8" )
      warnlog "Please check " + sFile + " ( UTF8 encoded )!"
    else
      ListWrite ( sOLENames(), sFile )
      warnlog "Please check " + sFile + " !"
   end if
endcase

'-------------------------------------------------------------------------

sub LoadIncludeFiles
   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   gApplication = "WRITER"
   call GetUseFiles
end sub

'-------------------------------------------------------------------------

