'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: t_lists.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: tbo $ $Date: 2003/10/01 12:24:01 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : general routines to work with lists (arrays)
'*
'*******************************************************************
'* general information :
'* - entry 0 of the list is the counter
'* - you have to start loops everytime with 1 .. n
'*
' #1 ListCount           ' Returns the number of list entries
' #1 ListCopy            ' Copies one list to another (OrgList(), CopyList())
' #1 ListAllDelete       ' Deletes the complete list
' #1 ListInsert          ' Inserts a string into a list at a special number
' #1 ListAppend          ' Appends an entry to a list
' #1 ListDelete          ' Deletes the n'th entry out of the list (lsList(), EntryNumber)
' #1 ListDeleteString    ' Deletes a string out of the list (the first found string)
' #1 ListSort            ' Sorts a list with quicksort method, if the 2. parameter is FALSE => downward, else => upward
' #1 ListRead            ' Reads a file into a list (row for row)
' #1 ListReadAppend      ' Reads a file into a list and append it onto another existed list
' #1 ListWrite           ' Writes a list into a file (each entry is a row) => the file will be created new
' #1 ListWriteAppend     ' Writes a list into a file, but append all entries to the file
'*
'\******************************************************************

function ListCount ( lsList() as String ) as Integer
'Author: tz
'///Returns the number of list entries.
'///+<u>Input</u: The list (only string lists are possible)
'///+<u>Return</u>: The number of entries
   ListCount =  Val(lsList(0))
end function

'-------------------------------------------------------------------------

function ListCopy ( lsList1() as String, lsList2() as String ) as Boolean
'Author: tz
'///Copies all entries out of one list into another list.
'///+<u>Input</u>:<ol><lo>list which should be copied</li><li>An empty list</li></ol>After this function the 2nd list is a copy of the 1st list.
'///+<u>Return</u>: If copy of the list is correct this function returns TRUE otherweise FALSE

  Dim ii as Integer

   ListAllDelete ( lsList2() )
    for ii=1 to ListCount ( lsList1() )
       ListAppend ( lsList2(), lsList1(ii) )
    next ii

    if ListCount ( lsList1() ) = ListCount ( lsList2 () ) then
       ListCopy = TRUE
    else
       ListCopy = FALSE
    end if
end function

'-------------------------------------------------------------------------

sub ListAllDelete ( lsList() as String )
'Author: tz
'///Deletes a complete list.
'///+<u>Input</u>: The list (only string lists are possible)
    lsList(0) = "0"
end sub

'-------------------------------------------------------------------------

sub ListAppend ( lsList() as String, sNewEntry as String )
'Author: tz
'///Appends a new entry at the end of the list.
'///+<u>Input</u>: <ol><li>the list (only string lists are possible)</li><li>The new entry</li></ol>
   lsList(0) = Val(lsList(0)) + 1
   lsList( lsList(0) ) = sNewEntry
end sub

'-------------------------------------------------------------------------

function ListDelete ( lsList() as String, iNr as Integer ) as Boolean
'Author: tz
'///Deletes an entry out of the list on a defined position (iNr).
'///+<u>Input</u>: <ol><li>The list (only string lists are possible)</li><li>The position of the entry</li></ol>
'///+<u>Return</u>: TRUE if the entry was deleted otherweise FALSE
  Dim i%, ListenAnzahl as Integer

   ListenAnzahl = Val(lsList(0))
   if iNr > ListenAnzahl then
      ListDelete = FALSE
      Exit Function
   end if

   for i% = iNr to ListenAnzahl
      lsList( i% ) = lsList( i% + 1 )
   next i%

   lsList(0) = ListenAnzahl - 1

   ListDelete = TRUE
end function

'-------------------------------------------------------------------------

function ListDeleteString ( lsList() as String, sText as String ) as Boolean
'Author: tz
'///Deletes the 1st string in the list which is equal to the input string.
'///+<u>Input</u>: <ol><li>The list (only string lists are possible)</li><li>The string</li></ol>
'///+<u>Return</u>: TRUE if the entry was deleted otherwise FALSE
  Dim i as Integer : Dim EintragsNr as Integer : Dim ListenAnzahl as Integer

    ListenAnzahl = Val(lsList(0))
    EintragsNr = 0
    for i = 1 to ListenAnzahl
        if lsList(i) = sText then
           EintragsNr = i
           i = ListenAnzahl + 1
        end if
    next i
    if EintragsNr = 0 then
       ListDeleteString = FALSE
    else
       ListDeleteString = ListDelete ( lsList(), EintragsNr )
    end if
end function

'-------------------------------------------------------------------------

function ListInsert ( lsList() as String, ZeileNr%, sWert$ ) as Boolean
'Author: tz
'///Inserts a string at a defined position in the list.
'///+<u>Input</u>: <ol><li>The list (only string lists are possible)</li><li>The position</li><li>The string</li></ol>
'///+<u>Return</u>: TRUE if the entry was inserted otherwise FALSE
  Dim i% : Dim ListenAnzahl as Integer

    ListenAnzahl = Val(lsList(0))
    if ZeileNr% > ListenAnzahl then
      ListInsert = FALSE
      Exit Function
   end if

    ' Nach hinten verschieben, hinten beginnend
    for i% = ListenAnzahl to ZeileNr% step -1
      lsList( i%+1 ) = lsList( i% )
   next i%

    ' Einfuegen
   lsList( ZeileNr% ) = sWert$
    lsFile(0) = ListenAnzahl + 1
   ListInsert = TRUE

end function

'-------------------------------------------------------------------------

function ListRead ( lsList() as String, Datei$, optional sEncode as String ) as Boolean
'Author: tz
'///+Opens a file and insert all rows into a list (row for row).
'///+<u>Input</u>: <ol><li>The list (old list entries will be deleted)</li><li>The file</li><li><b>optional</b>: The encoding &quot;UTF8&quot;</li></ol>
'///+<u>Return</u>: TRUE or FALSE if this routine can read the file.
  Dim bUTF8 as Boolean
  Dim i%
  Dim CompareList(10000) as String

   if Dir( Datei$ ) = "" then
      Warnlog "ListRead: " + Datei$ + " is missing!"
      ListRead = FALSE
      exit function
   end if

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UFT8" OR UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead :" +  sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   ListAllDelete ( lsList() )                             ' clean up the list

   if bUTF8 =  TRUE then
      Dim textin as object, sfa as object, xInput as object                   ' for UTF-8-input-routines
      Dim iC as Integer

      textin = createUnoService( "com.sun.star.io.TextInputStream" )         ' uno-handling to input an UFT-8-File
      textin.setEncoding("utf8")                                             '
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )          '
      xInput = sfa.openFileRead( Datei$ )                                    '
      textin.setInputStream( xInput )                                        '

      do until textin.isEOF()                                                '
         i% = Val(lsList(0)) + 1
         lsList(0) = i%
         lsList( i% ) = textin.readLine()                                    '
      loop
      xInput.closeInput                                                      ' uno-file-close

    'INFO: (TZ) Only to workaround a problem with UNIX-Files...
      if Right ( lsList(i%), 1 ) = Chr(10) then
         lsList(i%) = Left ( lsList(i%), Len ( lsList(i%) ) - 1 )
      end if
    'INFO: (TBO) Remove the BOM http://www.unicode.org/versions/Unicode4.0.0/ch15.pdf
      if (left(lsList(1), 1) = chr(&HFEFF)) then
         lsList(1) = right(lsList(1), Len(lsList(1)) - 1)
      end if
   else
      Dim FileNum%

      FileNum% = FreeFile
      Open Datei$ for input  as #FileNum%

      do until EOF(#FileNum%) ' all from LIS-file
         i% = Val(lsList(0)) + 1
         lsList(0) = i%
         Line Input #FileNum%, lsList( i% )
      loop
      Close #FileNum%
   end if
   ListRead = TRUE
end function

'-------------------------------------------------------------------------

function ListWrite ( lsList() as String, Datei$, optional sEncode as String) as Boolean
'Author: tz
'///+Writes a list into a file (an existing file will be deleted before)
'///+<u>Input</u>: <ol><li>The list</li><li>The file</li><li><b>optional</b>: The encoding &quot;UTF8&quot;</li></ol>
'///+<u>return</u>: TRUE or FALSE if this routine can read the file.

  Dim bUTF8 as Boolean
  Dim i%

   if Dir (Datei$) <> "" then Kill(Datei$)                 ' the file must be deleted if you use 'UTF8'

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead :" +  sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   if bUTF8 =  TRUE then
     Dim textout as object, sfa as object, xOutput as object                  ' for UTF-8-output-routines

      textout = createUnoService( "com.sun.star.io.TextOutputStream" )        ' uno-handling to output an UFT-8-File
      textout.setEncoding("utf8")                                             '
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )           '
      xOutput = sfa.openFileWrite( Datei$ )                                   '
      textout.setOutputStream( xOutput )                                      '

      for i%=1 to ListCount ( lsList() )
         textout.writeString( lsList( i% ) + Chr(13) + Chr(10) )              '
      next i%
      xOutput.closeOutput                                                     ' uno-file-close
   else
     Dim FileNum% : Dim iLast%

      FileNum% = FreeFile
      Open Datei$ for Output  as #FileNum%
      iLast% = Val(lsList(0))
      i%=1
      do while i% <= iLast%
         Print #FileNum%, lsList(i%)
           i% = i% +1
      loop
      Close #FileNum%
   endif

   ListWrite = TRUE
end function

'-------------------------------------------------------------------------

function ListReadAppend( lsList() as String , Datei$, optional sEncode as String ) as Boolean
'Author: tz
'///+Appends a list into a file (If the file exists the file will be deleted before!).
'///+<u>Input</u>: <ol><li>The list</li><li>The file</li><li><b>optional</b>: The encoding &quot;UTF8&quot;</li></ol>
'///+<u>return</u>: TRUE or FALSE if this routine can read the file.

  Dim bUTF8 as Boolean
  Dim i%
  Dim CompareList() as String
  Dim isCounter as Integer
  Dim FileNum%

   if Dir( Datei$ ) = "" then
      Warnlog "ListReadAppend : " + Datei$ + " is missing!"
      ListReadAppend = FALSE
      exit function
   end if

   isCounter = ListCount ( lsList() )

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UFT8" OR UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead : " + sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   if bUTF8 =  TRUE then
      Dim textin as object, sfa as object, xInput as object                  ' for UTF-8-input-routines

      textin = createUnoService( "com.sun.star.io.TextInputStream" )         ' uno-handling to input an UFT-8-File
      textin.setEncoding("utf8")                                             '
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )          '
      xInput = sfa.openFileRead( Datei$ )                                    '
      textin.setInputStream( xInput )                                        '

      do until textin.isEOF()                                                '
         i% = Val(lsList(0)) + 1
         lsList(0) = i%
         lsList( i% ) = textin.readLine()                                    '
      loop
      xInput.closeInput                                                      ' uno-file-close

    'INFO: (TZ) Only to workaround a problem with UNIX-Files...
      if Right ( lsList(i%), 1 ) = Chr(10) then
         lsList(i%) = Left ( lsList(i%), Len ( lsList(i%) ) - 1 )
      end if
    '...
   else
      FileNum% = FreeFile
      Open Datei$ for input  as #FileNum%

      do until EOF(FileNum%)                            ' All from LIST-file
         i% =  Val(lsList(0)) + 1
         lsList(0) = i%
         Line Input #FileNum%, lsList( i% )
      loop
      Close #FileNum%
   end if

   ListReadAppend = TRUE

end function

'-------------------------------------------------------------------------

function ListWriteAppend( lsList() as String, Datei$, optional sEncode as String ) as Boolean
'Author: tz
'///+Writes a list into a file (If the files exist all entries will be appended).
'///+<u>Input</u>: <ol><li>The list</li><li>The file</li><li><b>optional</b>: The encoding &quot;UTF8&quot;</li></ol>
'///+<u>return</u>: TRUE or FALSE if this routine can read the file.

  Dim bUTF8 as Boolean
  Dim i%
  Dim DummyList (5000 ) as String

   if IsMissing ( sEncode ) = TRUE then
      bUTF8 = FALSE
   else
      if UCASE ( sEncode ) = "UTF8" then
         bUTF8 = TRUE
      else
         Warnlog "ListRead :" +  sEncode + " - Encoding is unkown!"
         bUTF8 = FALSE
      end if
   end if

   if bUTF8 =  TRUE then
     Dim sfa as object, xOutput as object, textout as object                 ' for UTF-8-output-routines

      ListRead ( DummyList(), Datei$, "utf8" )                               ' read old file in another list
      for i% = 1 to ListCount ( lsList() )
         ListAppend ( DummyList(), lsList(i%) )                              ' add the new list at the old list
      next i%

      textout = createUnoService( "com.sun.star.io.TextOutputStream" )       ' uno-handling to output an UFT-8-File
      textout.setEncoding("utf8")                                            '
      sfa = createUnoService( "com.sun.star.ucb.SimpleFileAccess" )          '
      xOutput = sfa.openFileWrite( Datei$ )                                  '
      textout.setOutputStream( xOutput )                                     '

      for i%=1 to ListCount (DummyList())
         textout.writeString( DummyList( i% ) + Chr(13) + Chr(10 )           '
      next i%
      xOutput.closeOutput                                                    ' uno-file-close
   else
    Dim FileNum%

     FileNum% = FreeFile
     Open Datei$ for Append  as #FileNum%

     for i% = 1 to Val(lsList(0))
        Print #FileNum%, lsList(i%)
      next i%

      Close #FileNum%
   end if
   ListWriteAppend = TRUE

end function

'-------------------------------------------------------------------------

sub ListSort ( lsList() as String, optional UpDown as Boolean )
'Author: tz
'///+Sorts a list upward per default or downward if optional parameter is FALSE with quicksort method.
'///+<u>Input</u>: Unsorted list

  Dim Listenanzahl as Integer, i as Integer, j as Integer
  Dim Zwischenspeicher as String

   ListenAnzahl = Val(lsList(0))
   for i=ListenAnzahl-1 to 1 step -1
      for j=1 to i
         if UpDown = FALSE then
            if uCase ( lsList(j) ) < uCase ( lsList(j+1) ) then            ' upward sorting
               Zwischenspeicher = lsList (j)                               ' invert value (i) with value (i+1)
               lsList (j) = lsList(j+1)
               lsList (j+1) = Zwischenspeicher
            end if
         else
            if uCase ( lsList(j) ) > uCase ( lsList(j+1) ) then            ' downward sorting
               Zwischenspeicher = lsList (j)                               ' invert value (i) with value (i+1)
               lsList (j) = lsList(j+1)
               lsList (j+1) = Zwischenspeicher
            end if
         end if
      next j
   next i
end sub

'-------------------------------------------------------------------------

sub gCompare2Lists ( ListOne() as String, ListTwo() as String )
'Author: tz
'///+Compares the 2nd list with the 1st list.
'///+<u>Input</u>: <ol><li>List one (should-list)</li><li>List two (Is-list)</li></ol>
   Dim lsListErr(1000) as String
   Dim i as Integer, j as Integer

   for i=1 to ListCount ( ListOne() )
       for j=1 to ListCount ( ListTwo() )
           if ListOne(i) = ListTwo(j) then

              printlog "in gCompare2Lists: " + ListOne ( i ) + " matched"
              ListDelete ( ListTwo(), j )
              j=1000
           end if
       next j
       if j<1000 then ListAppend ( lsListErr(), ListOne(i) )
   next i

   for i=1 to ListCount ( lsListErr() )
      Warnlog "new  -> : " + lsListErr(i)
   next i

   for i=1 to ListCount ( ListTwo() )
      Warnlog "lost <- : " + ListTwo(i)
   next i
end sub

