'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: basepilo.inc,v $
'*
'*  $Revision: 1.3.2.2 $
'*
'*  last change: $Author: msc $ $Date: 2003/09/01 09:21:15 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : marc.schwanz@sun.com
'*
'* short description : Base AP
'*
'************************************************************************
'*
' #1 tFileAutopilotDatabaseImport
' #1 tFileAddressDataSource
' #1 tFileAutopilotForm
' #1 tFileAutopilotReport
'*
'\***********************************************************************

'-------------------------------------------------------------------------
' File -> Autopilot -> StarOffice 5.2 Database Import
' Author: Joerg Sievers (js93788), x66608
'-------------------------------------------------------------------------

testcase tFileAutopilotDatabaseImport
 Dim Adresstext as string
 Dim ItemsOfList as integer
 '/// Execute Slot File Autopilot Database Import which is behind
 '/// + the File -> Autopilot -> Database Import menu item.
 FileAutopilotDatabaseImport
 Kontext "DatabaseImport"
  call Dialogtest(DatabaseImport)
  '/// Verifying that Database Import dialog is visible.
  if NOT DatabaseImport.Exists(3) then
    warnlog "Database import autopilot was not visible!"
   else
    printlog "Database import: Page 1/5"
    Kontext "TabSelectSource"
     call Dialogtest(TabSelectSource)
     '/// Type cursorkeys down and up and reading the first selected string.
     Address.TypeKeys "<DOWN><UP>"
     Adresstext = Address.GetSelText(1)
     if Adresstext <> "" then
       warnlog "The address of the .sdb file should be empty if pilot was started!"
       warnlog "BugId: #85872"
     end if
     '/// Clicking Browse button.
     Browse.Click
     sleep(2)
     Kontext "OeffnenDlg"
      '/// Cheching Open file dialog.
      if NOT OeffnenDlg.Exists(3) then
        warnlog "The open dlg was not visible!"
       else
        call Dialogtest(OeffnenDlg)
        '/// Entering <i>base\update\input\testbase.sdb</i> as file.
        Dateiname.SetText gTesttoolPath & ConvertPath("base\update\input\testbase.sdb")
        sleep(2)
        Oeffnen.Click
        sleep(3)
      end if
     Kontext "TabSelectSource"
      '/// Verifying that the selected source is the same as selected in load dialog.
      call Dialogtest(TabSelectSource)
      TabSelectSource.TypeKeys "<SHIFT TAB>"
      Adresstext = Address.GetSelText(1)
      printlog "Selected database file: " & Adresstext
      if InStr( Adresstext , "testbase.sdb" ) = 0 then
        warnlog "The selected file was not taken to the pilot dialog! Bug!"
      end if
     Kontext "DatabaseImport"
      '/// Clicking 'Next' button.
      NextPageButton.Click
      sleep(2)
    printlog "Database import: Page 2/5"
     Kontext "TabElements"
      call Dialogtest(TabElements)
      '/// Verifying defaults of checkboxes.
      if NOT NewDatasource.IsChecked then
       warnlog "'Import data source' should be checked but it is not!"
       NewDatasource.Check
      end if
      if ImportQueries.IsChecked = FALSE then
       warnlog "'Import queries' should be checked but it is not!"
       ImportQueries.Check
      end if
      if ImportFormDocs.IsChecked = FALSE then
        warnlog "'Import form documents' should be checked but it is not!"
        ImportFormDocs.Check
      end if
     Kontext "DatabaseImport"
      '/// Clicking 'Next' button.
      NextPageButton.Click
      sleep(2)
    printlog "Database import: Page 3/5"
     Kontext "TabFormImport"
      call Dialogtest(TabFormImport)
      '/// Verifying stored directory entry.
      Address.TypeKeys "<DOWN><UP>"
      Address.TypeKeys "<HOME>"
      Address.TypeKeys "<SHIFT END>"
      Adresstext = ""
      Adresstext = Address.GetSelText(1)
      if Adresstext = "" then
        warnlog "The directory was empty!"
      end if
      Address.SetText gOfficePath & ConvertPath("user\work")
      ItemsOfList = Formslist.GetItemCount
      '/// Verifying that only one form has been found.
      if ItemsOfList = 0 OR ItemsOfList > 1 then
        warnlog "There should be only ONE form not more or less!?"
      end if
      '/// Clicking 'Browse' button.
      Browse.Click
      sleep(2)
      Kontext "OeffnenDlg"
       '/// Checking Open dialog.
       if NOT OeffnenDlg.Exists(3) then
         warnlog "The open dlg was not visible!"
        else
         call Dialogtest(OeffnenDlg)
         OeffnenDlg.Cancel
         sleep(2)
       end if
     Kontext "TabFormImport"
      call Dialogtest(TabFormImport)
      '/// Checking radio buttons.
      SelectNone.Click
      sleep(1)
      SelectAll.Click
      sleep(1)
     Kontext "DatabaseImport"
      '/// Clicking 'Next' button.
      NextPageButton.Click
      sleep(2)
    printlog "Database import: Page 4/5"
     Kontext "TabQueryImport"
      call Dialogtest(TabQueryImport)
      ItemsOfList = Destination.GetItemCount
      '/// Verifying that there are two entries in the data source destination.
      if ItemsOfList < 2 then
        warnlog "There should be at least two entries in the data source destination!"
      end if
      '/// Checking radio buttons.
      SelectNone.Click
      sleep(1)
      SelectAll.Click
      sleep(1)
     Kontext "DatabaseImport"
      '/// Clicking 'Next' button.
      NextPageButton.Click
      sleep(2)
    printlog "Database import: Page 5/5"
     Kontext "TabSummaries"
      call Dialogtest(TabSummaries)
      '/// Verifying name of the new datasource.
      Adresstext = ""
      Adresstext = NewDatasourceName.GetText
      if Adresstext = "" then
        warnlog "The name of the new datasource was empty! Bug!"
      end if
      if OpenNewDatasource.IsChecked = FALSE then
        warnlog "Open new datasource-checkbox should be checked per default!"
      end if
  Kontext "DatabaseImport"
   '/// Cancel the dialog.
   CancelButton.Click
  end if
endcase

'-------------------------------------------------------------------------
'/// File -> Autopilot -> Address Datasource ///'
'/// Author: Joerg Sievers (js93788), x66608 ///'
'-------------------------------------------------------------------------

testcase tFileAddressDataSource
 Dim i as integer
 Dim s as integer
 Dim TableCounts as integer
 Dim CountOfPages as integer
 Dim AddBkSourceName as string
  if gPlatgroup = "unx" then
    '3 choices on non-windows systems
    s = 3
   else
    s = 5
  end if
  for i = 1 to s
  '/// Calling slot File -> Autopilot -> Datasource
   FileAutopilotAddressDataSource
    sleep(1)
    Kontext "AddressSourceAutopilot"     
     if AddressSourceAutopilot.Exists(3) then
       Kontext "TabAddressDataSourceAutoPilot"
        call Dialogtest(TabAddressDataSourceAutoPilot)
        select case i

         case 1 :  '/// Checking Mozilla as option.
                   Mozilla.Check
                   printlog "-----------------------"
                   printlog "Checking Mozilla"
                  Kontext "AddressSourceAutopilot"
                   printlog "Dialog: Address source autopilot"
                   NextButton.Click
                   sleep(3)
                  ' if there is no source an active should be visible
                  Kontext
                   if Active.Exists then
                     printlog "Dialog: Errorbox, clicking OK"
                     Active.OK
                    else
                     Kontext "TabSelectTable"
                      call Dialogtest(TabSelectTable)
                      printlog "Tabpage: Select table"
                      TableCounts = TableSelectionList.GetItemCount
                      if TableCounts < 1 then warnlog "Why is the list of tables which can be selected as address book source empty?"
                     Kontext "AddressSourceAutopilot"
                      printlog "Dialog: Address source autopilot, clicking next button"
                      NextButton.Click
                      sleep(1)
                     Kontext "TabDataSourceName"
                      call Dialogtest(TabDataSourceName)
                      printlog "Tabpage: Data source name"
                      AddBkSourceName = SourceName.GetText
                      if AddBkSourceName = "" then warnlog "On the data source name tab page the default name was empty"
                   end if

         case 2 :  '/// Checking LDAP as option.
                   LDAP.Check
                   printlog "-----------------------"
                   printlog "Checking LDAP"
                  Kontext "AddressSourceAutopilot"
                   printlog "Dialog: Address source autopilot"
                   NextButton.Click
                   sleep(1)
                  Kontext "TabAdditionalSettings"
                   call Dialogtest(TabAdditionalSettings)
                   printlog "Dialog: Additional settings"
                   Settings.Click
                   sleep(2)
                   Kontext "DataSourceAdministration"
                    printlog "Dialog: Data source administration"
                    if DataSourceAdministration.Exists(3) then
                     call Dialogtest(DataSourceAdministration)
                      printlog "checking count of tab pages"
                      CountOfPages = TabControl.GetPageCount
                      sleep(3)
                      try
                        printlog "Page count: " & CountOfPages
                        if CountOfPages <> 3 then
                          warnlog "There are " & CountOfPages & " tab pages available instead of 3!"
                        end if
                       catch
                        Kontext
                          printlog "Dialog: Error dlg box, clicking OK"
                          if Active.Exists(3) then Active.Ok
                      endcatch
                      Kontext "DataSourceAdministration"
                       try
                        TabControl.SetPage TabTables
                        Kontext "TabTables"
                          printlog "TRY tab page: Tables"
 '                        call Dialogtest(TabTables)
                        catch
                         Kontext
                          if Active.Exists(3) then
                           Kontext
                            printlog "Dialog: Error dlg box, clicking MORE"
                            'more button
                            Active.Click(5)
                            Kontext "SQLException"
                             printlog "Dialog: Starbase error / SQL exception, OK"
                             call Dialogtest(SQLException)
                             SQLException.Ok
                            Kontext
                             printlog "Dialog: Error dlg box, OK"
                             Active.Ok
                            Kontext "TabTables"
                             printlog "Tab page: Tables"
 '                            call Dialogtest(TabTables)
                          else
                             warnlog "There should be an error dlg that the connection to a LDAP connection failed because the settings are empty (default)!"
                          end if
                       endcatch
                      try
                       Kontext "DataSourceAdministration"
                        printlog "Dialog: Data source administration -> tab page LDAP"
                        TabControl.SetPage TabLDAP
                       catch
                       Kontext
                        printlog "Dialog: Error dlg box, OK"
                        if Active.Exists(3) then Active.OK
                       Kontext "DataSourceAdministration"
                        printlog "Dialog: Data source administration -> tab page LDAP"
                        TabControl.SetPage TabLDAP
                      endcatch
                      Kontext "TabLDAP"
                       printlog "Tab page: LDAP"
 '                      call Dialogtest(TabLDAP)
                       printlog "Host name: sun-ds.central.Sun.COM"
                       HostName.SetText "sun-ds.central.Sun.COM"
                       printlog "Base DN: dc=sun;dc=com"
                       BaseDN.SetText "dc=sun;dc=com"
                      Kontext "DataSourceAdministration"
                       TabControl.SetPage TabGeneral
                       Kontext "TabGeneral"
                        printlog "Tab page: General"
 '                       call Dialogtest(TabGeneral)
                         Kontext
                          if Active.Exists(3) then
                           if Active.GetRT = 376 then
                            warnlog "LDAP Connection failed! #97105"
                            warnlog Active.GetText
                            Kontext
                             Active.OK
                           end if
                          end if
                       Kontext "TabGeneral"
                        AddBkSourceName = SourceName.GetText
                        if AddBkSourceName = "" then warnlog "On the general tab page the default name was empty!"
                       Kontext "DataSourceAdministration"
                        TabControl.SetPage TabTables
                       Kontext "TabTables"
                        printlog "Tab page: Tables"
 '                       call Dialogtest(TabTables)
                         Kontext
                          if Active.Exists(3) then
                           if Active.GetRT = 376 then
                            warnlog "LDAP Connection failed! #97105"
                            warnlog Active.GetText
                            Kontext
                             Active.OK
                           end if
                          end if
                       Kontext "DataSourceAdministration"
                        DataSourceAdministration.OK
                        printlog "Dialog: Data source administration, OK"
                        sleep(1)
                         Kontext
                          if Active.Exists(3) then
                           if Active.GetRT = 376 then
                            warnlog "LDAP Connection failed! #97105"
                            warnlog Active.GetText
                            Kontext
                             Active.OK
                           end if
                          end if
                     else
                      warnlog "Data Source Administration dialog was not visible!"
                    end if

         case 3 :  '/// Checking Other as option.
                   Other.Check
                   printlog "-----------------------"
                   printlog "Checking Other data sources"
                   printlog " - nearly the same like LDAP"
                   printlog "   only the tabpage is instead of LDAP at first 'general' to select a database type"
                  Kontext "AddressSourceAutopilot"
                   NextButton.Click
                   sleep(1)
                  Kontext "TabAdditionalSettings"
                   Settings.Click
                   sleep(2)
                   Kontext "DataSourceAdministration"
                    if DataSourceAdministration.Exists(3) then
                     call Dialogtest(DataSourceAdministration)
                      CountOfPages = TabControl.GetPageCount
                      try
                        printlog "Page count: " & CountOfPages
                        if CountOfPages <> 3 then
                          warnlog "There are " & CountOfPages & " tab pages available instead of 3!"
                        end if
                       catch
                        Kontext
                          if Active.Exists(3) then Active.Ok
                      endcatch
                      Kontext "DataSourceAdministration"
                       TabControl.SetPage TabTables
                        Kontext
                         if Active.Exists(3) then
                           Kontext
                            if Active.GetRT = 376 then
                              try
                                Active.Ok
                               catch
                                warnlog "The 'StarOffice Base' message box with 'More' button has not been detected by Testtool!"
                                Active.Close
                              endcatch
                            end if
                           Kontext "TabTables"
 '                           call Dialogtest(TabTables)
                           Kontext "DataSourceAdministration"
                            TabControl.SetPage TabGeneral
                          else
                            warnlog "There should be an error dlg that the connection to a LDAP connection failed because the settings are empty (default)!"
                         end if
                      Kontext "TabGeneral"
 '                      call Dialogtest(TabGeneral)
                        AddBkSourceName = SourceName.GetText
                        if AddBkSourceName = "" then warnlog "On the general tab page the default name was empty!"
                       Kontext "DataSourceAdministration"
                        DataSourceAdministration.OK
                        sleep(1)
                        Kontext
                         if Active.Exists(3) then
                            if Active.GetRT = 376 then
                              try
                                Active.Ok
                               catch
                                warnlog "The 'StarOffice Base' message box with 'More' button has not been detected by Testtool!"
                                Active.Close
                              endcatch
                             else
                               warnlog "2nd time: The 'StarOffice Base' message box with 'More' button has not been detected by Testtool! Aborting this test!"
                            end if
                          else
                           warnlog "There should be an error dlg that the connection to a dBase connection failed because the settings are empty (default)!"
                         end if
                        Kontext "TabAdditionalSettings"
                         call Dialogtest(TabAdditionalSettings)
                     else
                      warnlog "Data Source Administration dialog was not visible!"
                    end if

                   '/// Checking Outlook (on Windows systems only)
         case 4 :  Outlook.Check
                   printlog "-----------------------"
                   printlog "Checking MS Outlook"
                  Kontext "AddressSourceAutopilot"
                   NextButton.Click
                   sleep(1)
                  ' if there is no source an active should be visible
                  
                  Kontext
                   if Active.Exists(2) then
                     printlog "No outlook is installed on this mashine!"
                     Active.OK
                    else
                     Kontext "TabSelectTable"
                     if TabSelectTable.exists(5) then
                        TableSelectionList.select 1
                        sleep(1)                        
                        Kontext "AddressSourceAutopilot"
                            if NextButton.isEnabled then
                                NextButton.Click
                            else
                                warnlog "after selecting a table the next button is disabled."                                
                            endif
                     endif
                     Kontext "TabDataSourceName"
                      if TabDataSourceName.exists(3) then
                        AddBkSourceName = SourceName.GetText
                        if AddBkSourceName = "" then warnlog "On the data source name tab page the default name was empty"
                      else
                        warnlog "The datasource Page doesn't exists."
                      endif                      
                   end if

         case 5 :  '/// Checking Windows system address book (Windows systems only)
                   WinSystem.Check
                   printlog "-----------------------"
                   printlog "Checking Windows system data source"
                   printlog " - exactly the same as 'Outlook' (at this moment)"
                  Kontext "AddressSourceAutopilot"
                   NextButton.Click
                   sleep(1)
                  ' if there is no source an active should be visible
                  Kontext
                   if Active.Exists(2) then
 '                   warnlog Active.GetText
                     printlog "No source => messagebox!"
                     Active.OK
                    else
                     Kontext "TabDataSourceName"
                      AddBkSourceName = SourceName.GetText
                      if AddBkSourceName = "" then warnlog "On the data source name tab page the default name was empty"
                 end if
         case else : warnlog "Why " & i & " choice instead of " & s & " in this autopilot possible?"
        end select
      else
       warnlog "The autopilot dialog wasn't visible! Test stopped!"
     end if
    Kontext "AddressSourceAutopilot"
     CancelButton.Click
     sleep(1)
  next i
endcase


'-------------------------------------------------------------------------

testcase tFileAutopilotForm
   Dim ExitPilot, i as integer, j as integer
   Dim IsLoaded as boolean, LoadTime as integer
   Dim CountOfEntries as integer
   printlog "  * File AutoPilot Form"
   printlog "File / Autopilot / Form"

   call hNewDocument
   if ActivateAutoPilot ( "Form" ) = FALSE then Goto endsub

   'first page (when dialog is fast enogh visible)'
   Kontext "ChooseDatabase"
    call DialogTest(ChooseDatabase)
    '/// Checking that 'binary fields'-radio buttons are not enabled by default.
    if BinaryFieldsAsImages.IsEnabled = TRUE or IgnoreBinaryFields.IsEnabled = TRUE then
     warnlog "'Display of binary fields' radio buttons should NOT be enabled if no database selected with a binary field (like Adabas)!"
     warnlog "See -> BugId 94212"
    end if
    '/// Counting the list of data sources.
    CountOfEntries = DataSource.GetItemCount
    Sleep (2)
    '/// If < 1 then warning (bibliography is everytime installed).
    if CountOfEntries < 1 then
      warnlog "In Data Source is " & CountOfEntries & " entry! Where is 'Bibliography'-database as default? Test stoped!"
       Kontext "ChooseDatabase"
       CancelBtn.Click
       call hCloseDocument
       call hCloseDocument
      Goto endsub
     else
      '/// ELSE Select Bibliography entry.
      DataSource.Select("Bibliography")
      sleep(2)
      CountOfEntries = TablesOrQueries.GetItemCount
      '/// Counting the 'tables or queries'.
      if CountOfEntries < 1 then
         warnlog "In 'Tables or queries' is " & CountOfEntries & " entry! Where is 'biblio'-table as default? Test stoped!"
         Goto endsub
       else
         '/// Selecting biblio entry.
         TablesOrQueries.Select("biblio")
         TablesOrQueries.Select("biblio") ' select twice. I don't know why, but so it works.
         sleep(2)
         '/// Checking that 'binary fields'-radio buttons are not enabled by default.
         if BinaryFieldsAsImages.IsEnabled = TRUE or IgnoreBinaryFields.IsEnabled = TRUE then
          warnlog "'Display of binary fields' radio buttons enabled? Does 1st database in the list really support thioos feature (e.g. it is an Adabas database)?"
         end if
         '/// Checking the state of buttons; checking entries
         CountOfEntries = ExistingFields.GetItemCount
         if CountOfEntries <> 31 then warnlog "There are not 31 exsisting fields available! There are " & CountOfEntries & " fields available!"
         if MoveSelected.IsEnabled = TRUE then warnlog "'Move selected' button enabled. Nothing selected!"
         if MoveAll.IsEnabled = FALSE then warnlog "'Move all' button not enabled!"
         if RemoveSelected.IsEnabled = TRUE then warnlog "'Remove selected' button enabled. Nothing selected!"
         if RemoveAll.IsEnabled = TRUE then warnlog "'Remove All' button enabled. Nothing in list!"
         if NextBtn.IsEnabled = TRUE then warnlog "'Next' button enabled but nothing selected!"
         '/// Move all.
         MoveAll.Click
         sleep(2)
         '/// Remove all.
         RemoveAll.Click
         sleep(2)
         '/// Select 1st entry in 'Existing fields'.
         ExistingFields.Select(1)
         sleep(2)
         '/// Move selected.
         MoveSelected.Click
         sleep(2)
         '/// Next button.
         NextBtn.Click
         sleep(5)
         '/// second page
        for i = 1 to 5
         Kontext "ChooseDatabase"
         '/// Checking all modes.
         select case i

          case 1 : call Dialogtest(ChooseDatabase)
                   printlog "- 'As Datasheet'"
                   CountOfEntries = PageStyles.GetItemCount
                   if CountOfEntries <> 19 then warnlog "There should be 19 page styles available but there are " & CountOfEntries & " available?!"
                   for j = 1 to CountOfEntries-1
                      PageStyles.Select(j)
                      sleep(2)
                   next j
                   PageStyles.Select(1)
                   if TiledLook.IsEnabled = TRUE then
                    TiledLook.Check
                   end if
                   sleep(2)
                   if ScaledLook.IsEnabled = TRUE then
                    ScaledLook.Check
                   end if
                   sleep(2)
                   'go to next mode
                   printlog "- 'Columnar labels left'"
                   ColumnarLabelsLeft.Click

          case 2 : if TiledLook.IsEnabled = TRUE then
                    TiledLook.Check
                   end if
                   sleep(2)
                   if ScaledLook.IsEnabled = TRUE then
                    ScaledLook.Check
                   end if
                   sleep(2)
                   'go to next mode
                   printlog "- 'Columnar labels on top'"
                   ColumnarLabelsOnTop.Click

          case 3 : if TiledLook.IsEnabled = TRUE then
                    TiledLook.Check
                   end if
                   sleep(2)
                   if ScaledLook.IsEnabled = TRUE then
                    ScaledLook.Check
                   end if
                   sleep(2)
                   'go to next mode
                   printlog "- 'In Blocks Labels Left'"
                   InBlocksLabelsLeft.Click

          case 4 : if TiledLook.IsEnabled = TRUE then
                    TiledLook.Check
                   end if
                   sleep(2)
                   if ScaledLook.IsEnabled = TRUE then
                    ScaledLook.Check
                   end if
                   sleep(2)
                   'go to next mode
                   printlog "- 'In Blocks Labels Above'"
                   InBlocksLabelsAbove.Click

          case 5 : if TiledLook.IsEnabled = TRUE then
                    TiledLook.Check
                   end if
                   sleep(2)
                   if ScaledLook.IsEnabled = TRUE then
                    ScaledLook.Check
                   end if
                   sleep(2)
         end select
       next i
      end if
    end if
   '/// Cancel
   CancelBtn.Click
   call hCloseDocument
  call hCloseDocument
endcase

'-------------------------------------------------------------------------
' File -> Autopilot -> Report
' Author: Joerg Sievers (js93788), x66608
'-------------------------------------------------------------------------

testcase tFileAutopilotReport
 Dim xFieldCnt as integer
 Dim xModCnt as integer
 Dim xModTabSelect as integer
 Dim i as integer
 Dim xSelectFieldStrg as string
 Dim xSelectGrpStrg as string
 Dim xStrgOfBx as string
   call hNewDocument
   if ActivateAutoPilot ( "Report" ) = FALSE then Goto endsub
  Kontext "AutoPilotReport"
   call Dialogtest(AutoPilotReport)
   printlog "Page 1/5 (start)"
  '/// Checking that the 'Data Source' listbox is usable.
   if AvailDatabase.IsEnabled then AvailDatabase.Select("Bibliography")
   '/// Select 1st entry in the 'Data Source' listbox.
   sleep(2)
   if Tables.IsEnabled then Tables.Select("biblio")
   ' do twice because of a bug   
   Tables.Select("biblio")
   '
   '/// If 'Tables or queries' listbox is also available, select 1st entry.
   sleep(2)
   xFieldCnt = AvailFields.GetItemCount
   '/// Check the count of 'Existing fields'.
   if xFieldCnt = 0 then
     '/// Warn and stop the test if there are 0 entries.
     warnlog "There are 0 fields in the database available for the report?!?!?"
     goto endsub
    else
      AvailFields.Select(1)
      '/// Select 1st field.
      AddSelected.Click
      sleep(1)
      ' add two fileds because of a bug.
      AddSelected.Click
      '
      '/// Add only that field to 'Table Selection'.
      sleep(1)
      xModCnt = AvailFields.GetItemCount
      '/// Now checking the count of 'Existing Fields' again and warn if it's not -1 from the first count.
      if xModCnt = xFieldCnt then
        warnlog "After adding 2 field to 'Table Selection' the count of 'Existing Fields' has not been reduced by 1!"
       else
        if xModCnt = xFieldCnt-2 then
          printlog "The count of 'Existing fields is ok after adding 2 field to 'Table Selection'."
          xModTabSelect = SelectedFields.GetItemCount
          if xModTabSelect <> 2 then
            warnlog "The added field is not listed on the other side in 'Table Selection' box!!!"
           else
            xSelectFieldStrg = SelectedFields.GetItemText(1)
          end if
         else
          warnlog "The count of 'Existing Fields' is wrong after adding 2 field to 'Table Selection'!"
        end if
      end if
      '/// Clicking 'Next' button.
      NextBtn.Click
      printlog "Page 1/6 (end)"
     Kontext "AutoPilotReport"
      call Dialogtest(AutoPilotReport)
      sleep(1)
      NextBtn.Click
      printlog "Page 2/6 (end)"
     Kontext "AutoPilotReport"
      call Dialogtest(AutoPilotReport)
      printlog "Page 3/6 (start)"
      '/// Verifying that the field is also visible on next page.
      xSelectGrpStrg = AvailGrouping.GetItemText(1)
      if xSelectFieldStrg <> xSelectGrpStrg then
       warnlog "The selected field has not been transfered to the next page!"
      end if
      AvailGrouping.Select(1)
      AddSelected2.Click
      sleep(1)
      xModCnt = 0
      xModCnt = SelectedGrouping.GetItemCount
      if xModCnt = 0 then
       warnlog "The selection has not been taken to 'Groupings' list!"
      end if
      '/// Clicking 'Next' button.
      NextBtn.Click
      printlog "Page 3/6 (end)"
     Kontext "AutoPilotReport"
      call Dialogtest(AutoPilotReport)
      printlog "Page 4/6 (start)"
      '/// Clicking 'Next' button.
      NextBtn.Click
      printlog "Page 4/6 (end)"
     Kontext "AutoPilotReport"
      call Dialogtest(AutoPilotReport)
      printlog "Page 5/6 (start)"
      '/// Verifying that there are 19 types of 'data layouts' and 11 types of 'headers and footers' available and selecting each of them.
      xModCnt = 0
      xModCnt = DataLqayout.GetItemCount
      if ( iSprache = 81 ) then
        qaerrorlog "because of bug 112034 there are only 17 report templates available"
        if xModCnt <> 17 then
            warnlog "There are not 17 types of layouts available. There are " & xModCnt & " layouts available!"
        end if
      else
        if xModCnt <> 19 then
            warnlog "There are not 19 types of layouts available. There are " & xModCnt & " layouts available!"
        end if
      endif
      for i = 1 to xModCnt
       DataLqayout.Select(i)
       xStrgOfBx = DataLqayout.GetItemText(i)
       printlog "Layout No." & i & " :" & xStrgOfBx
       sleep(1)
      next i
      xModCnt = 0
      xModCnt = PageLayout.GetItemCount
      if xModCnt <> 11 then
       warnlog "There are not 11 types of header & footer layouts available. There are " & xModCnt & " layouts available!"
      end if
      for i = 1 to xModCnt
       PageLayout.Select(i)
       xStrgOfBx = PageLayout.GetItemText(i)
       printlog "Layout No." & i & " :" & xStrgOfBx
       sleep(1)
      next i
      '/// Checking that 'Landscape' is default and selecting 'Portrait' to test the button.
      if Landscape.IsChecked then
        Portrait.Check
       else
        warnlog "Default is 'landscape' but it was not checked!"
        Landscape.Check
      end if
      '/// Clicking 'Next' button.
      NextBtn.Click
      printlog "Page 5/6 (end)"
     Kontext "AutoPilotReport"
      call Dialogtest(AutoPilotReport)
      printlog "Page 6/6 (start)"      
      '/// Verifying that dynamic report template is default.
      if NOT DynamicReportTemplate.IsChecked then
        warnlog "Default is 'Dynamic Report Template' but it was not checked!"
        DynamicReportTemplate.Check
      end if
      '/// Clicking 'Dynamic Report Template' browse button.
      TemplatePathBtn.click
      sleep(2)
     Kontext "SpeichernDlg"
      '/// Verifying that the save dialog appears.
      call Dialogtest(SpeichernDlg)
      '/// Cancel save dialog.
      SpeichernDlg.Cancel
      sleep(2)
     Kontext "AutoPilotReport"
      '/// Selecting Static report.
      StaticReport.Check
      if NOT DynamicReportTemplate.IsChecked then
        if ModifyReportTemplate.IsEnabled then warnlog "Why is 'Modify report template' enabled?"
        if UseReportTemplateImmediately.IsEnabled then warnlog "Why is 'Use report template immediatly' enabled?"
       else
        warnlog "Why is 'Dynamic Report Template' checked when 'Static report' is also checked?"
      end if
      StaticPathBtn.Click
      sleep(2)
     Kontext "SpeichernDlg"
      '/// Verifying that the save dialog appears.
      call Dialogtest(SpeichernDlg)
      '/// Cancel save dialog.
      SpeichernDlg.Cancel
      sleep(2)
     Kontext "AutoPilotReport"
      StaticPath.SetText "123"
      if NOT NextBtn.IsEnabled then
        warnlog "Bug: #101966 - Filename length must be >= 4 characters but there is no reason why."
        StaticPath.SetText "1234"
        if NOT NextBtn.IsEnabled then warnlog "Generally the 'Create' button is not available!?"
      end if
      '/// Click once 'Back' button to check the functionality.
      BackBtn.Click
      '/// Try to check 'Lendscape' the test had changed before to 'Portrait'.
      '///+ If it is possible the back button works.
      Landscape.Check
      sleep(2)
      '/// Cancel the dialog via 'Cancel' button.
      CancelBtn.Click
   end if
  call hCloseDocument
endcase
