'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: docbook_001.inc,v $
'*
'*  $Revision: 1.1.2.3 $
'*
'*  last change: $Author: jsi $ $Date: 2004/02/06 09:03:24 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Library for DocBook XML Im-/Export Test
'*
'************************************************************************
'*
' #1 tDocBookXMLtestdocs        'Main testcase for DocBook XML test 
' #1 fLoadDocBookXMLAndSaveIt   'Helper function for loading and saving 
' #1 fInitialDocBookXMLSetting  'Checks the availibility of the Docbook filter
'*
'\***********************************************************************

testcase tDocBookXMLtestdocs
    Dim sSourceDocuments(500) as string
    Dim i as integer, iNumberOfDocuments as integer

    '/// Checking under Tools -> XML Filter Settings that the DocBook XSLT Filter
    '///+ has been installed. If not install them from <i>global\input\xslt_stylesheets\docbook_xhtml.jar</i>.
    if fInitialDocBookXMLSetting = FALSE then
        warnlog "The DocBook XSLT filter has not been installed!"
        warnlog "Aborting!"
        goto endsub
    end if    
    '/// Calculating how many documents are in that directory (max. 500)
    if hDirectoryExists(sSourcePath) then
        '/// Get the file list and put it in a list (max. 500 per directory!).
        call GetAllFileList(sSourcePath, "*.xml" , sSourceDocuments())  
        iNumberOfDocuments = ListCount(sSourceDocuments())
        printlog iNumberOfDocuments & " DocBook XML files found in " & sSourcePath & "."  
        if iNumberOfDocuments > 0 then
            for i = 2 to iNumberOfDocuments
                '/// Call the testcase with each document.                                 
                call fLoadDocBookXMLAndSaveIt(sSourceDocuments(i))
            next i
        else
            warnlog "Path " & sSourcePath & " contains no documents!"
        end if
    else
        warnlog "Path " & sSourcePath & " has not been found!"
    end if
endcase

'-------------------------------------------------------------------------

testcase fLoadDocBookXMLAndSaveIt(sSourceDocument as string)                
 Dim sExpFileName as string
 Dim sFileName as string
 
 sFileName = DateiExtract(sSourceDocument)
 sExpFileName = sDestinationPath & sFileName
 
 '/// Loading the file.
 printlog "Loading " & sFileName & "."
 call hDateiOeffnen (sSourceDocument)
 '/// If the document can not be loaded as XML file (wrong Doctype) it will be loaded as ASCII.
 Kontext "AsciiFilterOptionen"
    if AsciiFilterOptionen.Exists(2) then
        AsciiFilterOptionen.Cancel
        QAErrorLog "The DTD may be does not match. Work around in SRX645 builds is to load it as ASCII file."
        Goto Endsub
    else     
        printlog "global::tools::inc::t_files.inc::IsItLoaded"
        call IsItLoaded
        sleep(3)
        if GetDocumentCount = 1 then
            warnlog "Document " & sFileName & " has not been loaded! It won't be exported! verify manually!" 
        else
            printlog "Saving as " & sExpFileName       
            '/// Saving the document in the work directory.
            if hSpeichernUnterKill(sExpFileName) = TRUE then
                printlog "global::tools::inc::t_files.inc::IsItSaved"
                call IsItSaved
                sleep(3)
                '/// Closing the document also if there is a verification dialog.
                call hCloseAndLooseDocument
                sleep(3)     
                if XMLWellformed (sExpFileName) = FALSE then
                    '/// Checking the well formness of the saved document.
                    warnlog "XML-file " & sExpFileName & " not well formed or does not exist!"
                else
                    '/// Open the exported document.
                    call hDateiOeffnen (sExpFileName)                    
                    printlog "global::tools::inc::t_files.inc::IsItLoaded"
                    call IsItLoaded
                    sleep(3)
                    if GetDocumentCount = 1 then
                        warnlog "EXPORTED document " & sExpFileName & " has not been loaded! It won't be exported! verify manually!" 
                    else
                        '/// Closing the exported document.
                        call hCloseDocument                        
                    end if
                end if
            else
                warnlog "Exporting XML file (" & sExpFileName & ") failed!"                    
            end if
        end if    
    end if
endcase  

'-------------------------------------------------------------------------

sub fInitialDocBookXMLSetting as boolean
'last change          : Wed Feb 04 15:27:08 MET 2004 (JSI)
'This small function adds the XHTML- and DocBook XSLT stylesheets from
'OOo 1.1.1 to the office if there are no XSLT stylesheets installed.
'The result is TRUE if the packages are already available or if they 
'have been installed successfully in this routine.
 Dim iCountOfDefaultXSLTStyles as integer
 Dim sFilterPackagePath as string
 
 'Setting boolean to FALSE
 fInitialDocBookXMLSetting = FALSE
 '/// Opening new document.
 printlog "- Opening new (application) document."
 call hNewDocument
'/// Calling the menu item <i>Tools -&gt; XML Filter Settings</i>
  ToolsXMLFilterSettings
  printlog "- XML Filter Settings"
  Kontext "XMLFilterSettings"
   call Dialogtest (XMLFilterSettings)
   '/// Checking if there are any XSLT stylesheets available.
   printlog " + Checking if there are any XSLT stylesheets available."
   iCountOfDefaultXSLTStyles = FilterList.GetItemCount
   if iCountOfDefaultXSLTStyles < 2 then
     '/// If no or less then 2 XML filter (in respin sets the Excel XSLT filter is included) 
     '///+ is available: Adding two filters which can be installed via setup (DocBook and XHTML).
     printlog "If no XML filter is available: Adding two filters which can be installed via setup (DocBook and XHTML)."
     '///+ The packages will be used from &quot;qatesttool/global/input/xslt_stylesheets/docbook_xhtml.jar&quot;
     sFilterPackagePath = ConvertPath(gTestToolPath & "global\input\xslt_stylesheets\docbook_xhtml.jar")
     OpenPackage.Click
     Kontext "OeffnenDlg"
      call Dialogtest (OeffnenDlg)
      Dateiname.SetText sFilterPackagePath
      sleep(3)
      Oeffnen.Click
      sleep(3)
     Kontext
      if Active.Exists(3) then
       if Active.GetRT = 304 then
         printlog Active.GetText
         Active.OK
        Kontext "XMLFilterSettings"
         iCountOfDefaultXSLTStyles = FilterList.GetItemCount
         printlog "Checking again the count of installed XSLT stylesheets."
         if iCountOfDefaultXSLTStyles < 2 then
          warnlog "docbook_001.inc::fInitialDocBookXMLSetting: It was not possible to add XML filters!"
          warnlog "docbook_001.inc::fInitialDocBookXMLSetting: Test aborted!"
          exit sub
         else
          fInitialDocBookXMLSetting = TRUE
         end if
       end if
      end if
   else
    fInitialDocBookXMLSetting = TRUE
   end if
   Kontext "XMLFilterSettings"
   '/// Closing the &apos;XML Filter Settings&apos;-dialog.
   printlog "+- Closing the 'XML Filter Settings'-dialog."
   CloseBtn.Click
 '/// Closing the opened application document.
 printlog "- Closing the opened application document."
 call hCloseDocument
end sub
